Bug 1145100

Summary: Review Request: zeromq2 - Software library for fast, message-based applications
Product: [Fedora] Fedora Reporter: Thomas Spura <tomspur>
Component: Package ReviewAssignee: Robin Lee <robinlee.sysu>
Status: CLOSED RAWHIDE QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: medium    
Version: rawhideCC: package-review, robinlee.sysu, steve.traylen
Target Milestone: ---Flags: robinlee.sysu: fedora-review+
gwync: fedora-cvs+
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2014-11-14 13:41:24 UTC Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Bug Depends On:    
Bug Blocks: 1045884    

Description Thomas Spura 2014-09-22 11:39:11 UTC
Spec URL: http://tomspur.fedorapeople.org/review/zeromq2.spec
SRPM URL: http://tomspur.fedorapeople.org/review/zeromq2-2.2.0-11.fc20.src.rpm
Description:
The 0MQ lightweight messaging kernel is a library which extends the
standard socket interfaces with features traditionally provided by
specialized messaging middle-ware products. 0MQ sockets provide an
abstraction of asynchronous message queues, multiple messaging
patterns, message filtering (subscriptions), seamless access to
multiple transport protocols and more.
Fedora Account System Username: tomspur

This is a compat package so we can update the zeromq package to version 4. This package will exist until all current dependencies of zeromq2 are ported to newer packages

Comment 1 Steve Traylen 2014-10-06 07:16:08 UTC
Do you actually need this? In the past I have rolled the compat package into 
the normal package. See http://pkgs.fedoraproject.org/cgit/activemq-cpp.git/tree/activemq-cpp.spec?h=el6 for example.

Comment 2 Thomas Spura 2014-10-23 08:14:29 UTC
I think both approaches are possible in principle. Yet, in my opinion adding compat packages to the same spec is not as legible as two different packages, and you always rebuild all packages, if you change anything in your spec file as you need to bump your "globrelease"...

I cannot find a guideline, that explicitly forbids your approach, but I would have thought so...

So in summary: Yes I need this :)

Comment 3 Robin Lee 2014-11-13 12:00:54 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[!]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf %{buildroot} present but not required
[x]: Sources contain only permissible code or content.
[!]: Each %files section contains %defattr if rpm < 4.4
     Note: %defattr present but not needed
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[-]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x ]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
[x]: Packages must not store files under /srv, /opt or /usr/local
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.

===== SHOULD items =====

Generic:
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[!]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Scriptlets must be sane, if used.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Package should not use obsolete m4 macros
     Note: Some obsoleted macros found, see the attachment.
     See: https://fedorahosted.org/FedoraReview/wiki/AutoTools
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).


Rpmlint
-------
Checking: zeromq2-2.2.0-11.fc22.x86_64.rpm
          zeromq2-devel-2.2.0-11.fc22.x86_64.rpm
          zeromq2-2.2.0-11.fc22.src.rpm
zeromq2-devel.x86_64: W: only-non-binary-in-usr-lib
zeromq2.src: W: invalid-url URL: http://www.zeromq.org <urlopen error timed out>
3 packages and 0 specfiles checked; 0 errors, 2 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint zeromq2 zeromq2-devel
zeromq2.x86_64: W: invalid-url URL: http://www.zeromq.org timed out
zeromq2.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libzmq.so.1.0.1 /lib64/libm.so.6
zeromq2-devel.x86_64: W: only-non-binary-in-usr-lib
2 packages and 0 specfiles checked; 0 errors, 3 warnings.
# echo 'rpmlint-done:'



Requires
--------
zeromq2 (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    libc.so.6()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libm.so.6()(64bit)
    libpgm-5.2.so.0()(64bit)
    libpthread.so.0()(64bit)
    librt.so.1()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    libuuid.so.1()(64bit)
    libuuid.so.1(UUID_1.0)(64bit)
    rtld(GNU_HASH)

zeromq2-devel (rpmlib, GLIBC filtered):
    /usr/bin/pkg-config
    libzmq.so.1()(64bit)
    zeromq2(x86-64)



Provides
--------
zeromq2:
    libzmq.so.1()(64bit)
    zeromq2
    zeromq2(x86-64)

zeromq2-devel:
    pkgconfig(libzmq)
    zeromq2-devel
    zeromq2-devel(x86-64)



Source checksums
----------------
http://download.zeromq.org/zeromq-2.2.0.tar.gz :
  CHECKSUM(SHA256) this package     : 43904aeb9ea6844f72ca02e4e53bf1d481a1a0264e64979da761464e88604637
  CHECKSUM(SHA256) upstream package : 43904aeb9ea6844f72ca02e4e53bf1d481a1a0264e64979da761464e88604637


AutoTools: Obsoleted m4s found
------------------------------
  AC_PROG_LIBTOOL found in: zeromq-2.2.0/configure.in:55
  AM_CONFIG_HEADER found in: zeromq-2.2.0/configure.in:13


Generated by fedora-review 0.5.2 (63c24cb) last change: 2014-07-14
Command line :/usr/bin/fedora-review -r -b 1145100
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG


===== Extra items ======
[!] zeromq2-devel should also conflict zeromq3-devel
[!] Summary and description should reflect that this package is for ZeroMQ 2.

Comment 4 Thomas Spura 2014-11-13 16:52:22 UTC
Many thanks for the review.

(In reply to Robin Lee from comment #3)
> [!]: Each %files section contains %defattr if rpm < 4.4
>      Note: %defattr present but not needed

removed

> ===== SHOULD items =====
> 
> Generic:
> [!]: Package has no %clean section with rm -rf %{buildroot} (or
>      $RPM_BUILD_ROOT)

Still no %clean there, as it is not needed anymore.


> ===== EXTRA items =====
> 
> Generic:
> [!]: Package should not use obsolete m4 macros
>      Note: Some obsoleted macros found, see the attachment.
>      See: https://fedorahosted.org/FedoraReview/wiki/AutoTools

sed'ed in %prep.


> AutoTools: Obsoleted m4s found
> ------------------------------
>   AC_PROG_LIBTOOL found in: zeromq-2.2.0/configure.in:55
>   AM_CONFIG_HEADER found in: zeromq-2.2.0/configure.in:13

see above

> ===== Extra items ======
> [!] zeromq2-devel should also conflict zeromq3-devel
> [!] Summary and description should reflect that this package is for ZeroMQ 2.

both fixed.

changelog:
- cleaning ups according to review (#1145100)
- remove %%defattr
- mention version 2 in summary and description
- remove obsolted autotools m4s


Spec URL: http://tomspur.fedorapeople.org/review/zeromq2.spec
SRPM URL: http://tomspur.fedorapeople.org/review/zeromq2-2.2.0-12.fc20.src.rpm

Comment 5 Robin Lee 2014-11-14 02:28:39 UTC
> SRPM URL: http://tomspur.fedorapeople.org/review/zeromq2-2.2.0-12.fc20.src.rpm
This URL returns 404.

Comment 6 Thomas Spura 2014-11-14 08:55:29 UTC
(In reply to Robin Lee from comment #5)
> > SRPM URL: http://tomspur.fedorapeople.org/review/zeromq2-2.2.0-12.fc20.src.rpm
> This URL returns 404.

Should be working now. I scp'ed the wrong file there.

Comment 7 Robin Lee 2014-11-14 09:36:15 UTC
A typo 'obsolted' in the latest changelog.

Package approved by cheeselee

Comment 8 Thomas Spura 2014-11-14 09:51:03 UTC
New Package SCM Request
=======================
Package Name: zeromq2
Short Description: Software library for fast, message-based applications - Version 2
Upstream URL: http://www.zeromq.org
Owners: tomspur
Branches: f21 epel7
InitialCC:

Comment 9 Thomas Spura 2014-11-14 09:51:34 UTC
(In reply to Robin Lee from comment #7)
> A typo 'obsolted' in the latest changelog.
> 
> Package approved by cheeselee

Thanks again.

I'll fix the typo, when importing to git.

Comment 10 Gwyn Ciesla 2014-11-14 12:50:45 UTC
Git done (by process-git-requests).

Comment 11 Thomas Spura 2014-11-14 13:41:24 UTC
Building in rawhide:
http://koji.fedoraproject.org/koji/taskinfo?taskID=8142278

Will wait for the imports into other branches, when the exact transition of the depending packages is clear.